"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.error.cause.js");
require("core-js/modules/es.error.to-string.js");
require("core-js/modules/es.array.from.js");
require("core-js/modules/es.array.is-array.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.date.to-string.js");
require("core-js/modules/es.function.name.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/es.regexp.test.js");
require("core-js/modules/es.regexp.to-string.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AgoraEventEmitter = void 0;
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.map.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _logger = require("../logger");
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; } /**
 * 事件发射器
 */
/**@en
 * Event emitter
 */
var AgoraEventEmitter = exports.AgoraEventEmitter = /*#__PURE__*/function () {
  function AgoraEventEmitter() {
    (0, _classCallCheck2["default"])(this, AgoraEventEmitter);
    //@internal
    (0, _defineProperty2["default"])(this, "_eventMap", new Map());
  }
  return (0, _createClass2["default"])(AgoraEventEmitter, [{
    key: "once",
    value: function once(evt, cb) {
      var _this = this;
      var wrapper = function wrapper() {
        _this.off(evt, wrapper);
        cb.apply(void 0, arguments);
      };
      this.on(evt, wrapper);
      return this;
    }
  }, {
    key: "on",
    value: function on(evt, cb) {
      var _this$_eventMap$get;
      var cbs = (_this$_eventMap$get = this._eventMap.get(evt)) !== null && _this$_eventMap$get !== void 0 ? _this$_eventMap$get : [];
      cbs.push(cb);
      this._eventMap.set(evt, cbs);
      return this;
    }
  }, {
    key: "off",
    value: function off(evt, cb) {
      var cbs = this._eventMap.get(evt);
      if (cbs) {
        this._eventMap.set(evt, cbs.filter(function (it) {
          return it !== cb;
        }));
      }
      return this;
    }
  }, {
    key: "removeAllEventListeners",
    value: function removeAllEventListeners() {
      this._eventMap.clear();
    }
  }, {
    key: "emit",
    value: function emit(evt) {
      var _this$_eventMap$get2;
      var cbs = (_this$_eventMap$get2 = this._eventMap.get(evt)) !== null && _this$_eventMap$get2 !== void 0 ? _this$_eventMap$get2 : [];
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      var _iterator = _createForOfIteratorHelper(cbs),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var cb = _step.value;
          try {
            cb && cb.apply(void 0, args);
          } catch (e) {
            //cb exception should not affect other callbacks
            var error = e;
            var details = error.stack || error.message;
            (0, _logger.getLogger)().error("[event] handling event ".concat(evt, " fail: ").concat(details));
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return this;
    }
  }]);
}();