"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AgoraObservable = void 0;
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.set.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _events = require("./events");
var AgoraObservable = exports.AgoraObservable = /*#__PURE__*/function () {
  function AgoraObservable() {
    (0, _classCallCheck2["default"])(this, AgoraObservable);
    (0, _defineProperty2["default"])(this, "_eventBus", new _events.AgoraEventEmitter());
    (0, _defineProperty2["default"])(this, "_observers", 0);
    (0, _defineProperty2["default"])(this, "_observerSet", new Set());
  }
  return (0, _createClass2["default"])(AgoraObservable, [{
    key: "addObserver",
    value: function addObserver(observer) {
      var _this = this;
      if (this._observerSet.has(observer)) {
        return;
      }
      var eventKeys = Object.keys(observer);
      eventKeys.forEach(function (eventKey) {
        if (typeof observer[eventKey] === 'function') {
          _this._eventBus.on(eventKey, observer[eventKey]);
        }
      });
      this._observers++;
      this._observerSet.add(observer);
    }
  }, {
    key: "removeObserver",
    value: function removeObserver(observer) {
      var _this2 = this;
      var eventKeys = Object.keys(observer);
      eventKeys.forEach(function (eventKey) {
        if (typeof observer[eventKey] === 'function') {
          _this2._eventBus.off(eventKey, observer[eventKey]);
        }
      });
      this._observers--;
      this._observerSet["delete"](observer);
    }
  }, {
    key: "notifyObservers",
    value: function notifyObservers(eventName) {
      var _this$_eventBus;
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      (_this$_eventBus = this._eventBus).emit.apply(_this$_eventBus, [eventName].concat(args));
    }
  }, {
    key: "countOfObservers",
    value: function countOfObservers() {
      return this._observers;
    }
  }]);
}();